/******************************************************************************************************************
*Title: EFIEW  Desc
*Created by: CK
*Created on: March 1, 2020
*Last Modified on: May 13, 2022
*Last Modified by: CK
*Purpose: Descriptives 
	
*****************************************************************************************************************/

*From ELMPS 2018
use "$elmps/elmps 2018 xs v2.0 all.dta", clear

gen breakdown=.
*Public sector
replace breakdown=1 if ussectrp>=1 & ussectrp<=2 & usemp1==1

*Private agriculture
replace breakdown=2 if usecac1d==0 & usemp1==1 & ussectrp>=3 & ussectrp<=6

*Non-ag private outside est. 
replace breakdown=3 if usecac1d>=1 & usecac1d<. & usemp1==1 & ussectrp>=3 & ussectrp<=6 & usestblp==2

*Non-ag private in est. 1-24
replace breakdown=4 if usecac1d>=1 & usecac1d<. & usemp1==1 & ussectrp>=3 & ussectrp<=6 & usestblp==1 & usfirm_size>=1 & usfirm_size<=3

*Non-ag private in est. 25+
replace breakdown=5 if usecac1d>=1 & usecac1d<. & usemp1==1 & ussectrp>=3 & ussectrp<=6 & usestblp==1 & usfirm_size>=4 & usfirm_size<=7

*Check
tabu breakdown if usemp1==1, miss

la def Lbreakdown 1 "Public sector" 2 "Private agriculture" 3 "Non-ag. private outside est." ///
4 "Non-ag private in est. 1-24" 5 "Non-ag private in est. 25+"

la val breakdown Lbreakdown

*Social insurance
tabu breakdown ussocinsp, miss

recode ussocinsp (1=100) (2=0)

gen weight=ceil(expan_indiv)

*Table
tabout breakdown [aw=expan_indiv] if usemp1==1 using "$output/Situating emp.xls", ///
cells(col) replace oneway f(1)

tabout breakdown if usemp1==1 using "$output/Situating emp.xls", ///
cells(sum expan_indiv) append sum oneway f(0)

tabout breakdown [aw=expan_indiv] if usemp1==1 using "$output/Situating emp.xls", ///
cells(mean ussocinsp) append sum oneway f(0)


clear

**************
*Desc on ent. for data section
**************
use "$workingdata/ELMPS_Harmonized", clear

	d, short
	codebook hhid
**************
*Desc on ent. by formality
**************	
tabout  firm_size  act1_collapsed region ///
	 legal_state ///
	 kap_  firm_age ///
	 relout_ non_relout_ sloc_ /// 
	 sex educlvl3 usocp1d_cat agegrp3 formality_basic formality_basic ///
	 [aw=weight] using "$output/desc by formality.xls",  cells(col) replace ptotal(single)
	 
	 table is_est [pw=weight],c(mean formal)
	 
	 table formality_basic [pw=weight], c(mean rev_wrkr_ median rev_wrkr)
	 
