*******************************************************************
*******     EFIEW ELMPS HH Ent 	   ********************************
*******     Data creation do file  ********************************
*******  	v13: 2022.07.26 CK         ********************************
*******************************************************************

****2018 data
use "$elmps/elmps 2018 xs v2.0 all.dta", clear
keep indid q301 q15*
save "$elmps/2018 ent data.dta", replace


***********************Economic activity recoding******************
use "$elmps/elmps 2018 rep xs 88_18 v2.0.dta", clear

keep if round!=1988 & usecac1d_cl!=.

duplicates drop round usecactp usecac1d_cl, force

keep round usecactp usecac1d_cl

foreach num of numlist 1/4 {
gen ent`num'ecactp=usecactp
gen ent`num'ecac1d=usecac1d_cl
}

drop usecactp usecac1d_cl

save "$elmps/Ec Ac coding.dta", replace

use "$elmps/Ec Ac coding.dta", clear
keep round ent1* 
save "$elmps/Ec Ac 1 coding.dta", replace

use "$elmps/Ec Ac coding.dta", clear
keep round ent2* 
save "$elmps/Ec Ac 2 coding.dta", replace

use "$elmps/Ec Ac coding.dta", clear
keep round ent3* 
save "$elmps/Ec Ac 3 coding.dta", replace

use "$elmps/Ec Ac coding.dta", clear
keep round ent4* 
save "$elmps/Ec Ac 4 coding.dta", replace


*************************Repeated cross section*********************************

use "$elmps/elmps 2018 rep xs 88_18 v2.0.dta", clear

keep if round==2018

merge 1:1 indid using "$elmps/2018 ent data.dta", update
tabu _merge
drop _merge


********************************************************************************
*********************************Enterprise level*******************************
********************************************************************************

*Economic activity

foreach num of numlist 1/4 {

gen ent`num'ecactp=q15104_`num' if round==2018

}

merge m:1 round ent1ecactp using "$elmps/Ec Ac 1 coding.dta", update
tabu _merge
drop if _merge==2
drop _merge

merge m:1 round ent2ecactp using "$elmps/Ec Ac 2 coding.dta", update
tabu _merge
drop if _merge==2
drop _merge

merge m:1 round ent3ecactp using "$elmps/Ec Ac 3 coding.dta", update
tabu _merge
drop if _merge==2
drop _merge


merge m:1 round ent4ecactp using "$elmps/Ec Ac 4 coding.dta", update
tabu _merge
drop if _merge==2
drop _merge

********************************************************************************
***********************Owner characteristics*******************************
********************************************************************************

*Age groups
recode age (0/29=1) (30/49=2) (50/106=3), gen(agegrp3)
la def Lagegrp3 1 "<30" 2 "30-49" 3 "50+"
la val agegrp3 Lagegrp3

*Own education
recode educlvl (3=2) (4=3) (5=4) (6=4), gen(educlvl3)

la def lvlofedu 1 "Illiterate" 2 "Less than sec." 3 "Secondary" 4 "Higher education"

la val educlvl3 lvlofedu 


********************************************************************************
*******************************Enterprise chars*********************************
********************************************************************************


**Registration

foreach num of numlist 1/4 {
gen regist_`num'=.

replace regist_`num'=1 if q15115_`num'==1 & round==2018
replace regist_`num'=0 if (q15115_`num'==2 | q15115_`num'==3) & round==2018

la val regist_`num' yn1

}

***pays_taxes
***1=yes, 0=no
foreach num of numlist 1/4 {
gen pays_taxes_`num'=.
replace pays_taxes_`num'=q15301_13_`num' if q15301_13_`num'!=. & round==2018
recode pays_taxes_`num' (2=0)
}


**Formality

foreach num of numlist 1/4 {

gen formality_basic_`num'=1 if regist_`num'==1
replace formality_basic_`num'=0 if regist_`num'==0

label var formality_basic_`num' "Formality of establishment (basic definition)"

}

**Ownership

foreach num of numlist 1/4 {
gen partner_`num'=.

replace partner_`num'=0 if q15107_`num'==1 & round==2018
replace partner_`num'=1 if q15107_`num'==2 & round==2018

la val partner_`num' yn1

}


**Year of start
**********changed to 1950////2018
la def Lstarty 0 "Don't know" 1 "Before 1950" 2 "1950-1959" 3 "1960-1969" ///
4 "1970-1979" 5 "1980-1989" 6 "1990-1999" 7 "2000-2009" 8 "2010-2018"

foreach num of numlist 1/4 {
gen starty_`num'=.

replace starty_`num'=q15106_`num' if round==2018
replace starty_`num'=0 if starty_`num'==9998 & round==2018

replace starty_`num'=1 if starty_`num'>=1900 & starty_`num'<=1949
replace starty_`num'=2 if starty_`num'>=1950 & starty_`num'<=1959
replace starty_`num'=3 if starty_`num'>=1960 & starty_`num'<=1969
replace starty_`num'=4 if starty_`num'>=1970 & starty_`num'<=1979
replace starty_`num'=5 if starty_`num'>=1980 & starty_`num'<=1989
replace starty_`num'=6 if starty_`num'>=1990 & starty_`num'<=1999
replace starty_`num'=7 if starty_`num'>=2000 & starty_`num'<=2009
replace starty_`num'=8 if starty_`num'>=2010 & starty_`num'<=2018

la val starty_`num' Lstarty

}


**Type of workplace

la def Lloc   1 "own home"  2 "shop" 4 "office/flat/building" ///
5 "room/number of rooms" 6 "workshop/factory" 7 "kiosk" 8 "street vendor" ///
9 "mobile worker" 10 "street vendor with mobile cart" 11 "hut" ///
12 "drinks fridge" 14 "basket/ table"  15 "truck/pick-up truck" ///
16 "taxi" 17 "toc-toc"  18 "field/ farm" 97 "other"

foreach num of numlist 1/4 {
gen loc_`num'=.

replace loc_`num'=q15109_`num' if round==2018
replace loc_`num'=4 if loc_`num'==3 & round==2018
replace loc_`num'=4 if loc_`num'==8 & round==2018
replace loc_`num'=4 if loc_`num'==5 & round==2018
replace loc_`num'=5 if loc_`num'==4 & round==2018
replace loc_`num'=15 if loc_`num'==10 & round==2018
replace loc_`num'=16 if loc_`num'==11 & round==2018
replace loc_`num'=17 if loc_`num'==13 & round==2018
replace loc_`num'=18 if loc_`num'==12 & round==2018

replace loc_`num'=97 if loc_`num'==19 
replace loc_`num'=. if loc_`num'==98


la val loc_`num' Lloc
}

la def Lsloc 1 "Own home"  2 "Shop" 3 "Office/flat/building/rooms" ///
4 "Workshop/factory" 5 "Mobile worker" 6 "Street and kiosk vendors" ///
7 "Vehicle"

foreach num of numlist 1/4 {
gen sloc_`num'=.
replace sloc_`num'=loc_`num' if loc_`num'==1 | loc_`num'==2
replace sloc_`num'=3 if loc_`num'==4 | loc_`num'==5
replace sloc_`num'=4 if loc_`num'==6 
replace sloc_`num'=5 if loc_`num'==9 
replace sloc_`num'=6 if loc_`num'==7 | loc_`num'==8  | loc_`num'==10 | loc_`num'==11 ///
| loc_`num'==12 | loc_`num'==14    | loc_`num'==18 | loc_`num'==19           
replace sloc_`num'=7 if loc_`num'==15 | loc_`num'==16 | loc_`num'==17    

la val sloc_`num' Lsloc 
}





*current value of capital

foreach num of numlist 1/4 {

clonevar kap_`num'=q15110_`num' if round==2018

}


*Employees from outside the HH

foreach num of numlist 1/4 {
gen empout_`num'=.

replace empout_`num'=1 if q15201_`num'==1 & round==2018
replace empout_`num'=0 if q15201_`num'==2 & round==2018

la val empout_`num' yn1

}

*Relatives from outside the HH

foreach num of numlist 1/4 {
gen relout_`num'=.

replace relout_`num'=1 if q15202_1_`num'>0 & q15202_1_`num'<. & round==2018
replace relout_`num'=0 if (q15202_1_`num'==0 | q15201_`num'==2 | empout_`num'==0) & round==2018

la val relout_`num' yn1

}


*Non-relatives from outside the HH

foreach num of numlist 1/4 {
gen non_relout_`num'=.


replace non_relout_`num'=1 if q15202_2_`num'>0 & q15202_2_`num'<. & round==2018
replace non_relout_`num'=0 if (q15202_2_`num'==0 | q15201_`num'==2) & round==2018

la val non_relout_`num' yn1

}


*Number of household members

****for 2018, numbering different from previous years
foreach num of numlist 1/4 {

gen nhhemp_`num'=0
foreach num2 of numlist 1/3 {

replace nhhemp_`num'=nhhemp_`num'+1 if round==2018 & q15105_`num2'a_`num'!=.

replace nhhemp_`num'=0 if nhhemp_`num'<0
}
}

*Number of outside employees

foreach num of numlist 1/4 {
gen noutemp_`num'=0

replace noutemp_`num'=noutemp_`num'+q15202_`num' if round==2018 & q15202_`num'!=.

replace noutemp_`num'=0 if noutemp_`num'<0

}
*Fixed an error from the working paper version


*Number of total emps

foreach num of numlist 1/4 {
gen ntotemp_`num'=0

replace ntotemp_`num'=noutemp_`num'+nhhemp_`num'

}



*Economic activity collapsed

la def Lsecac1d 1 "Manufacturing and related trades" 2 "Construction" 3 "Wholesale and retail" ///
4 "Transportation and storage" 5 "Accommodation and food service" 6 "Various professional acts." ///
7 "Other service" 

foreach num of numlist 1/4 {

gen sent`num'ecac1d=. 
replace sent`num'ecac1d=1 if ent`num'ecac1d==1 | ent`num'ecac1d==2 | ent`num'ecac1d==3  
replace sent`num'ecac1d=2 if ent`num'ecac1d==5
replace sent`num'ecac1d=3 if ent`num'ecac1d==6
replace sent`num'ecac1d=4 if ent`num'ecac1d==7
replace sent`num'ecac1d=5 if ent`num'ecac1d==8
replace sent`num'ecac1d=6 if ent`num'ecac1d>=9 & ent`num'ecac1d<=17
replace sent`num'ecac1d=6 if ent`num'ecac1d==19
replace sent`num'ecac1d=7 if ent`num'ecac1d==18

la val sent`num'ecac1d Lsecac1d

}

****Net revenue/worker
	foreach num of numlist 1/4 {
	gen rev_wrkr_`num'=.
	replace rev_wrkr_`num'=q15501_`num'/ntotemp_`num' if round==2018 & ntotemp_`num'!=0
	la var rev_wrkr_`num' "Net revenue per worker"
}

****Firm age
			
	la def Lfirm_age 0 "0" 1 "1" 2  "2" 3 "3" 4 "4" 5 "5" ///
	6 "6" 7 "7" 8 "8-17" 9 "18-27" 10 "28+" 11 "Don't know", modify
	
	foreach num of numlist 1/4 {
	gen firm_age_`num'=.
	replace firm_age_`num'= 2018-q15106_`num' if round==2018 & q15106_`num'!=9998
	la var firm_age_`num' "Firm age at time of survey"
	clonevar c_firm_age_`num'=firm_age_`num'
	
	recode firm_age_`num' (8/17=8) (18/27=9) (28/200=10) 
	replace firm_age_`num'=11 if round==2018 & q15106_`num'==9998

	la val firm_age_`num' Lfirm_age
	
	}
	

	
save "$elmps/HH ent Ind HH data.dta", replace

********************************
***Creating owner characteristics***
********************************

*Use individual level data
use "$elmps/HH ent Ind HH data.dta", clear

recode usocp1d (1 2 3 =1) (4 5 =2) (7=3) (6 8 9 =4), gen(usocp1d_cat)
replace usocp1d_cat=4 if usemp1==0


la def Lusocp1d_cat 1 "Professional/technical" 2 "Other white collar" ///
3 "Blue collar craft" 4 "Blue collar non-craft"

la val usocp1d_cat Lusocp1d_cat
	

	
***Keeping owners of at least one enterprise (first in terms of work)
keep if (q301==q15105_1a_1 & round==2018) | (q301==q15105_1a_2 & round==2018) ///
		| (q301==q15105_1a_3 & round==2018) | (q301==q15105_1a_4 & round==2018)

gen ownerline=q301 if round==2018

keep indid sex educlvl3 agegrp3 usocp1d_cat hhid Findid round ussocinsp ownerline 


save "$elmps/HH ent owner char data.dta", replace

******************
*Enterprise data
******************

use "$elmps/HH ent Ind HH data.dta", clear

keep if pn==1

keep indid sent*ecac1d ent*ecactp ///
partner_* starty* sloc_* loc_* kap_* empout_* relout_* non_relout_* ///
region ntotemp_* partner_* ///
formality_basic_*   ///
rev_wrkr_* *firm_age_* ///
expan_indiv expan_hh round Findid indid hhid pn ///
q15105_1a_*  ///
nhhemp_* noutemp_* ent*ecac1d

reshape long sent@ecac1d ent@ecactp ///
partner_@ starty_@ sloc_@ loc_@ kap_@ empout_@ relout_@ non_relout_@ ///
ntotemp_@ ///
rev_wrkr_@ firm_age_@ c_firm_age_@ formality_basic_@ ///
q15105_1a_@  ///
nhhemp_@ noutemp_@  ent@ecac1d  ///
, i(indid) j(ent_num)

*Merge in owner data
gen ownerline=q15105_1a_ if round==2018

drop q15105_1a_

merge m:1 hhid ownerline using "$elmps/HH ent owner char data.dta"
tabu _merge
tabu _merge round

drop _merge

keep if entecac1d!=0 & starty_!=. & formality_basic!=.

save "$elmps/HH ent Ent data.dta", replace

*Stat on expanded economic activities 


************************************************
** Variable creation                          **
************************************************	

	
	la def yes_no 0 "No" 1 "Yes", modify
	la def Lyesno2 2 "No" 1 "Yes", modify
	
	***number of employees	
	rename ntotemp number_of_employees
	
	***Industry code
	rename entecactp act4
	la var act4 "Industry code (ISIC four digit)
	
	*firm age
	rename firm_age_ firm_age
	la var firm_age "Ent. age"
	

	***Establishment
	recode loc (2 4 5 6 7 11  =1) (1 8 9 10 12 14 15 16 17 18 97=0)  ///
			 (98 = .), gen(is_est)

	la def Lest 0 "Not establishment" 1 "Establishment", modify
	la val is_est Lest
	
	tabu loc is_est, miss
	
	*Capital
	gen capital=.
	replace capital=1 if inlist(kap_,1,2,3,4)
	replace capital=2 if inlist(kap_,5,6,7,98)

	label define Lcapital 1 "<5K" 2 "5K+", modify
	label val capital Lcapital
	label var capital "Invested capital amount (in EGP)"

	***legal_state
	**used partnership for ELMPS
	la def legal_state 1 "Sole Proprietorship" 0 "Collective Ownership", modify
	
	recode partner (0=1) (1=0), gen(legal_state)
	la var legal_state "Legal status of firm/establishment"
	la val legal_state legal_state
	drop partner

	gen data="Out est." if round==2018 & is_est==0
	replace data="In est." if round==2018 & is_est==1
	
	rename expan_hh weight

*************
*Create characteristics
*************	

	*firm size
	gen firm_size=.

	replace firm_size=1 if number_of_employees==1
	replace firm_size=2 if number_of_employees==2
	replace firm_size=3 if inlist(number_of_employees,3,4)  
	replace firm_size=4 if number_of_employees>=5  & number_of_employees<=24
	
	label define firm_size 1 "1" 2 "2" 3 "3-4" 4 "5-24", modify
	label value firm_size firm_size 
	label variable firm_size "Number of workers" 
	
	*act1
	gen act2=floor(act4/10000) 
	
	gen act1=.

	replace act1=0 if act2>=1 & act2<=3
	replace act1=1 if act2>=5 & act2<=9
	replace act1=2 if act2>=10 & act2<=33
	replace act1=3 if act2==35
	replace act1=4 if act2>=36 & act2<=39
	replace act1=5 if act2>=41 & act2<=43
	replace act1=6 if act2>=45 & act2<=47
	replace act1=7 if act2>=49 & act2<=53
	replace act1=8 if act2>=55 & act2<=56
	replace act1=9 if act2>=58 & act2<=63
	replace act1=10 if act2>=64 & act2<=66
	replace act1=11 if act2==68
	replace act1=12 if act2>=69 & act2<=75
	replace act1=13 if act2>=77 & act2<=82
	replace act1=14 if act2==84
	replace act1=15 if act2==85
	replace act1=16 if act2>=86 & act2<=88
	replace act1=17 if act2>=90 & act2<=93
	replace act1=18 if act2>=94 & act2<=96
	replace act1=19 if act2>=97 & act2<=98
	replace act1=20 if act2==99
	
	*what about 3, 20? 	3 => 4; 20=>18
	recode act1 (3=4) (19 20=18) (14=13)
	
	
	label define Lact1  /// 
	0  "A: Agriculture, forestry and fishing" ///
	1 "B: Mining"  2 "C: Manufacturing" ///
	4 "D E: Utilities" 5 "F: Construction" ///
	6 "G: Wholesale and retail trade ; repair of motor vehicles and motorcycles" /// 
	7 "H: Transportation and storage" 8 "I: Accommodation and food service activities" /// 
	9 "J: Information and communication" 10 "K: Financial and insurance activities"  ///
	11 "L: Real estate activities" 12 "M: Professional, scientific and technical activities"  ///
	13 "N O: Administrative and support service activities" ///
	15 "P: Education" 16 "Q: Human health and social work activities" 17 "R: Arts, entertainment and recreation" ///
	18 "S T U: Other service activities", modify
	
	label val act1 Lact1
	
	**New act1
	*Economic activity collapsed
	
	clonevar act1_collapsed=act1
	
	recode act1_collapsed (1 2 3=1) (5=2) (6=3) (7=4) (8=5) (9 10 11 12 13 14 15 16 17 19=6) (18=7)

	la def act1_collapsed 1 "Manufacturing and related trades" 2 "Construction" 3 "Wholesale and retail" ///
	4 "Transportation and storage" 5 "Accommodation and food service" 6 "Various professional acts." ///
	7 "Other service", modify

	label val act1_collapsed act1_collapsed

	**Log Revenue per worker
	gen ln_rev_wrk=ln(rev_wrk)
	la var ln_rev_wrk "Ln net revenue per worker"
		
	**Labels
	la def yn1 0 "No" 1 "Yes"
	
	la def Lformality_basic 0 "Informal" 1 "Formal"
	la val formality_basic Lformality_basic
	la var formality_basic "Formality"
	
	la var act1_collapsed "Industry"
	la var kap_ "Capital"
	la var relout_ "Relatives outside the HH employed"
	la var non_relout_ "Non-relatives outside the HH employed"
	la var sloc_ "Type of workplace"
	la var educlvl3 "Education"
	la var usocp1d_cat "Occupation" 
	la var agegrp3 "Age group"
	
	***Stat: firms with more than 24
	tabu number_of_employees if act1!=0
	
	**keep firms with number of workers 1-24
	keep if firm_size>=1 & firm_size<=4 
	**drop agriculture
	drop if act1==0

	
	*save dataset
	
	
	save "$workingdata/ELMPS_Harmonized", replace
