/******************************************************************************************************************
*Title: Formal/Informal Master Do (RDE Replication version)
*Created by: KWR
*Created on: December 10, 2019
*Last Modified on: 2023.01.11
*Last Modified by: CK
*Purpose : Egypt Formal/Informal Master Do file

	
*****************************************************************************************************************/
	clear all
	set more off
	capture log close
	set logtype text
	set scheme s1mono
	*Added
	version 16.1
	
	local date=c(current_date)
	local time=c(current_time)
	
	**Appropriate directory based on user

		if "`c(username)'"=="mcumanzala" {
	
		global base_dir ~/Dropbox (St. Kate's)/Egypt Formal Inform Ent. World Bank
	}	
	
		if "`c(username)'"=="Caroline" {
	
		global base_dir ~/Dropbox/Egypt Formal Inform Ent. World Bank/Drafts/RDE 2024
	}	
	
		
	if "`c(username)'"=="rahma120" | "`c(username)'"=="KWR" {
	
		global base_dir ~/Dropbox/Research Projects/Egypt Formal Inform Ent. World Bank
	}	
	
	
	if "`c(username)'"=="assaad" {
	
		global base_dir ~/Dropbox/Egypt Formal Inform Ent. World Bank
		
	}	
	
	*primary folders
	global data ${base_dir}/Data
	global log ${base_dir}/Log	
	global output ${base_dir}/Output
	global do ${base_dir}/Do

	*secondary folders
	global elmps ${data}/ELMPS analyses

					
	global workingdata ${data}/Working Data
	
	*run do files
	
	*Data preparation
	do "$do/EFIEW ELMPS HH Ent data v15 CK.do"
	
	
	*Descriptives
	do "$do/EFIEW Desc v3 CGK.do"
		
	*Regression models
	estimates clear	
	do "$do/EFIEW Models v9 CGK.do"
		
	*Grouping and cluster analyses
	do "$do/EFIEW ELMPS Grouping Analysis v8 CGK.do"
	
	do "$do/EFIEW ELMPS Cluster Analysis v11 CGK.do"
	
	do "$do/EFIEW Models SA v1 CGK.do"
	
	capture log close
	
